;;-----------------> POSITNS. LSP <----------------------------------
;;
;;         (c) DeLab 2001
;;
;;   !!!    -  QLEADER -  MTEXT !!!
;;
;;-------------------------------------------------------------------
;;-------------------------------------------------------------------

;*** error function ***

(defun *error* (msg)
(setq msg "* *")
(setvar "CLAYER" clay)
(setvar "CMDECHO" cmd1) ;  
(setvar "OSMODE" osm)
(setvar "ORTHOMODE" ortm)
(princ)
(princ msg)
(princ)
)
;
     (defun ton () ; ***   ****
       (command "_'layer" "s" "Thin 2" "")
	)
     (defun ton2 () ; ***   2 ****
       (command "_'layer" "s" "Thin 3" "")
	)
;
;------------------> SIKOKA (zn) <-----------------------------------
(defun sikoka( pz Scl / pt num smech)

 (setq num (getstring "\n :  "))
 (cond ((= (strlen num) 1) (setq smech (* 6.0 Scl)))
       ((= (strlen num) 2) (setq smech (* 4.0 Scl)))
       ((>=(strlen num) 3) (setq smech (* 2.0 Scl)))
 )
 (setq pt (list (- (car pz) smech) (+ (cadr pz) (* 1.3 Scl)))
 )
 (ton2)
 (command "TEXT" "r" pt (* 6 Scl) 0 num)
)
;------------------> POLKA (p2 p3) <-------2--OK------
(defun polka( px2 px3 Sc / pt1 pt2)
 (setq pt1 (list (car px2) (- (cadr px2) (* 10 Sc)))
       pt2 (list (car px3) (- (cadr px3) (* 10 Sc)))
     )
 (ton)
 (command "PLINE" px2 pt1 pt2 "")
 (if (> (car pt1) (car pt2)) (sikoka pt1 Sc) (sikoka pt2 Sc))
)
;------------------> POLKA-Next (p2 p3) <------3--------
(defun polkanxt ( x2 x3 Sc Nxt Dwn / pt pt1 pt2)
 (setq pt  (list (car x2) (- (cadr x2) (* Nxt Sc)))
       pt1 (list (car x2) (- (cadr x2) (* Dwn Sc)))
       pt2 (list (car x3) (- (cadr x3) (* Dwn Sc)))
     )
 (ton)
 (command "PLINE" pt pt1 pt2 "")
 (if (> (car pt1) (car pt2)) (sikoka pt1 Sc) (sikoka pt2 Sc))
)

;-------------------------------------------------
;-------------> MAIN POSITION <-------------------
;
(defun c:position( / p1 p2 p3 typ zn dlin cmd1 osm Scale)

 (setq cmd1 (getvar "CMDECHO")
       osm  (getvar "OSMODE")
	ortm	(getvar "ORTHOMODE")
	clay  (getvar "CLAYER"))

	(setq Scale (getvar "DIMSCALE"))	;      
	(if (= (getvar "TILEMODE") 0) 	;   
		(setq Scale 1)
	)
 
 (initget 3)
 (setvar "CMDECHO" 0)
 (setvar "OSMODE" 0)
 (setq dlin (* 14.0 Scale)) ;  

 (setq p1 (getpoint "\n  : "))

 (while p1
 (setvar "OSMODE" osm)
 (setvar "ORTHOMODE" 0)

  (setq p2 (getpoint p1 "\n   : "))
 (setvar "OSMODE" 0)
  (setq p3 (getpoint p2 "\n - : "))

  (setq typ 11)
  (while (and (/= typ 1) (/= typ 2) (/= typ 3) (/= typ 4) (/= typ 5) (/= typ 6)
              (/= typ 7) (/= typ 8) (/= typ 9) (/= typ 10) )
    (setq typ (getint "\n-  (1-10) <1>: "))
    (if (= typ nil) (setq typ 1))
  )
  (if (> (car p3) (car p2)) ; --------------------   
      (setq p3 (list (+ (car p2) dlin) (cadr p2))
            zn p3)
      (setq p3 (list (- (car p2) dlin) (cadr p2));  
            zn p2)
  )
	(ton)
	(command "QLEADER" p1 p2 p3) ; ***   ( MTEXT) ***

  (cond ((= typ 1)  (sikoka zn Scale))
        ((= typ 2)  (sikoka zn Scale)
                    (polka p2 p3 Scale))
        ((= typ 3)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20))
        ((= typ 4)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30))
        ((= typ 5)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30)
                    ( polkanxt p2 p3 Scale 30 40))
        ((= typ 6)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30)
                    ( polkanxt p2 p3 Scale 30 40) ( polkanxt p2 p3 Scale 40 50))
        ((= typ 7)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30)
                    ( polkanxt p2 p3 Scale 30 40) ( polkanxt p2 p3 Scale 40 50)
			  ( polkanxt p2 p3 Scale 50 60))
        ((= typ 8)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30)
                    ( polkanxt p2 p3 Scale 30 40) ( polkanxt p2 p3 Scale 40 50) 
			  ( polkanxt p2 p3 Scale 50 60) ( polkanxt p2 p3 Scale 60 70))
        ((= typ 9)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30)
                    ( polkanxt p2 p3 Scale 30 40) ( polkanxt p2 p3 Scale 40 50)
			  ( polkanxt p2 p3 Scale 50 60) ( polkanxt p2 p3 Scale 60 70)
			  ( polkanxt p2 p3 Scale 70 80))
       ((= typ 10)  ( sikoka zn Scale)
                    ( polka p2 p3 Scale)
			  ( polkanxt p2 p3 Scale 10 20) ( polkanxt p2 p3 Scale 20 30)
                    ( polkanxt p2 p3 Scale 30 40) ( polkanxt p2 p3 Scale 40 50)
			  ( polkanxt p2 p3 Scale 50 60) ( polkanxt p2 p3 Scale 60 70)
			  ( polkanxt p2 p3 Scale 70 80) ( polkanxt p2 p3 Scale 80 90))
   )
  (setq p1 (getpoint "\n  : "))   ;; If <ENTER> p1-> nil
 ) ;WHILE  -> p1 close

 (setvar "CLAYER" clay)
 (setvar "CMDECHO" cmd1)
 (setvar "OSMODE" osm)
 (setvar "ORTHOMODE" ortm)
(print "O.K.")
(princ)
)