;;------------------------------------------------------------------------
;; Adding for AutoCAD r14 12/08/97
;; 06/07/99  AutoCAD r15 (2000)
;; 
;;       - svarka
;;  
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;error function
(defun *error* (msg)
(setq msg "* *")
(setvar "CMDECHO" cmd1) ;  
(setvar "OSMODE" osm)
(princ)
(princ msg)
(princ)
)
;--------------------------------------------------------------------------
(defun c:svarka( / p1 p2 p3 p4 p5 tt qs Kont Vns scale  Polka HTxt BTxt ZTxt stext1 stext2 talf alfa cmd1 osm)

	(setq Scale (getvar "DIMSCALE"))	;      
	(if (= (getvar "TILEMODE") 0) 	;   
		(setq Scale 1)
	)
	(setq HTxt (* Scale 4))		;   
	(setq BTxt (* Scale 2))		;    ( 0,8)
	(setq ZTxt (* Scale 1))		;     ( 0,8)

 (setq osm (getvar "OSMODE"))  ;  
 (setq cmd1 (getvar "CMDECHO"))

 (setvar "OSMODE" 512) ; NEArest

 (initget 3)
 (setq p1 (getpoint "\n : "))

 (setvar "CMDECHO" 0)
 (setvar "OSMODE" 0)

  (setq p2 (getpoint p1 "\n : ") ; 
        p3 (getpoint p2 "\n  : ")  ;  
  )

      (setq Kont (getstring T "\n  ? <Y/N>: "))
	  (if (or (= Kont "Y") (= Kont "y"))
  (command "CIRCLE" p2 (* 1.6 Scale))	;  
	  )

      (setq Vns (getstring T "\n ? <Y/N>: "))
	  (if (or (= Vns "Y") (= Vns "y")) (setq Vns 1))

      (setq tt (getstring T "\n     < 5264-80-XX-%%140X>: "))
	  (if (or (null tt) (= tt ""))
		(setq tt " 5264-80-XX-%%140X")  ;    ( wwcade.shx)
	  )
	(setq qs (strlen tt))		; 
   (if (> qs 15) (setq Polka (* (+ BTxt ZTxt) (- qs 5)))
	(setq Polka (* (+ BTxt ZTxt) qs)) ;   ******   ******
   )
   (if (= Vns 1) ;   
    (if (> (car p3) (car p2)) ;   
     (progn (setq p3 (list (+ (car p2) (+ Polka (* 4 Scale))) (cadr p2))
                  p4 (list (+ (car p2) (* 4 Scale)) (- (cadr p2) (+ (* 1.3 Scale) HTxt)));  
      )
            (command "TEXT" p4 HTxt 0 tt) ;   4*Scale
      )
     (progn (setq p3 (list (- (car p2) (+ Polka (* 4 Scale))) (cadr p2)) ;   
                  p4 (list (+ (car p3) (* 2 Scale)) (- (cadr p3) (+ (* 1.3 Scale) HTxt)))
      )
            (command "TEXT" p4 HTxt 0 tt)
))
    (if (> (car p3) (car p2)) ;    -  
     (progn (setq p3 (list (+ (car p2) (+ Polka (* 4 Scale))) (cadr p2))
                  p4 (list (+ (car p2) (* 4 Scale)) (+ (cadr p2) (* 1.3 Scale)));  
      )
            (command "TEXT" p4 HTxt 0 tt) ;   4*Scale
      )
     (progn (setq p3 (list (- (car p2) (+ Polka (* 4 Scale))) (cadr p2)) ;   
                  p4 (list (+ (car p3) (* 2 Scale)) (+ (cadr p3) (* 1.3 Scale)))
      )
            (command "TEXT" p4 HTxt 0 tt)
   )))  ; ***   *** 

 (setq  alfa (atan (- (cadr p2) (cadr p1)) (- (car p2) (car p1))) ;   
         p4 (polar p1 alfa (* 6 Scale)) ;   6*Scale
         talf (/ (* alfa 180) pi)
  )
  (setq dist (- (* (distance p2 p4) 0.5) (* 2 BTxt)))

  (setq stext1 (getstring T"\n <XNX>: "))
	(if (or (null stext1) (= stext1 ""))
		(setq stext1 "XNX")
	)

  (setq stext2 (getstring "\n   : "))

  (if (< (car p2) (car p1)) 					;    
   (progn (setq p5 (polar p4 (- alfa (/ pi 2)) (* 1.7 Scale)) 
                p6 (polar p5 alfa (+ (* (distance p2 p4) 0.5) (* 2 BTxt))) ;  
                p7 (polar p6 (+ alfa (/ pi 2)) (* 7.4 Scale)) ;  
            )
             (if (> dist (* 2 Scale)) (progn 		;    2 ...
              (setq talf (+ 180 talf))			;   180 
              (command "TEXT" p6 HTxt talf stext1) 	;  
              (command "TEXT" p7 HTxt talf stext2)
        )   ))
     (progn (setq   p5 (polar p4 (+ alfa (/ pi 2)) (* 1.7 Scale)) ;  
                    p6 (polar p5 alfa dist)
                    p7 (polar p6 (- alfa (/ pi 2)) (* 7.4 Scale))
            )
             (if (> dist (* 2 Scale)) (progn
              (command "TEXT" p6 HTxt talf stext1)
              (command "TEXT" p7 Htxt talf stext2)
       )     ))
    )  ;  ***** end if (< (car p2) (car p1)

  (command "LINE" p1 p2 p3 "")		;   
  (command "SOLID" p1 p4 p5 p4 "")  	;  
;;;------------------------------------------------------------------

(setvar "CMDECHO" cmd1) ;  
(setvar "OSMODE" osm)

(print "O.K.")
(princ)
)
;;;------------------------------------------------------------------