

;;;;;;;;;;;;;;;  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun uzelned ( / cmd blpm apsz osmd clay cltp ccol dlnd pt3 pt3g pt3v
                   pt3vv pt3n pt7g pt7 pt7vv pt7v pt300 pt301 pt302 pt303 
                   pt304 pt305 pt306 pt307 label1 sset1 tvst edat32)

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq oscor (getvar "osnapcoord"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osnapcoord" 1) 

;  (defun lay_o ()
;    (command "_'layer" "s" "0" "")
;  ) ;_ end of defun
;  (lay_o)
;
;
;  (defun lay_gen4 ()
;    (command "_'layer" "m" "4" "c" "3" "" "")
;  ) ;_ end of defun

 (if (eq ndrn1 "1")
     (setq dlnd lndn)
     (setq dlnd lndu)
 )

  (defun ris_uzeln ()

    (setq pt3 '(0.0 0.0))
    (setvar "osmode" 0)
    (setvar "aperture" 1)
;;------------------   --------------------
 (setq pt3g  (polar pt3 pi (+ htv dlnd))
       pt3v  (polar pt3 (- (/ pi 2)) (* 2.5 htv))
       pt3vv (polar pt3 (/ pi 2) (* 2.0 htv))
       pt3n  (polar pt3 (- (/ pi 3)) (* 2 htv))
       pt7g  (polar pt3g (/ pi 2) htv)
       pt7   (polar pt7g 0 htv)
       pt7vv (polar pt7 (/ pi 2) (* 1.5 htv))
       pt7v  (polar pt7 (- (/ pi 2)) (* 3.5 htv))
   )
;;------------------   -----------------------
 (setq pt300 (polar pt3 0 dlnd)
       pt301 (polar pt3 pi htv)
       pt302 (polar pt301 (- (/ pi 2)) htv)
       pt303 (polar pt3 (- (/ pi 2)) (* 2 htv))
       pt304 (polar pt303 0 dlnd)
       pt305 (polar pt300 0 htv)
       pt306 (polar pt300 (/ pi 2) htv)
       pt307 (polar pt3 (- (/ pi 2)) htv)
 ) 
;;-------------------------------------------------------------------
(defun uzelvnned ()
   (command "_line" pt3 pt3n "")
      (setq label1 (entlast)
	    sset1   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt3v pt3 pt3g ""
            "_line" pt7v pt7 "")
      (command "_'layer" "s" "Thin 2" "")
  (command "_line" pt7 pt7g "")
  (command "_pline" pt7g "_a" "_r" (* 2.7 htv) pt3g 
                              "_r" (* 3 htv) pt7v 
                              "_r" (* 1.5 dlnd) pt3v 
                              "_r" (* 2 htv) pt3n 
                              "_r" (* 0.5 dlnd) pt3vv 
                              "_r" (* 1.1 dlnd) pt7vv 
                              "_r" (* 2.5 htv) pt7g "")
  (setvar "clayer" clay)
) ;_end of uzelvnned
;;--------------------------------------------------------------------
(defun uzelnarned ()
   (command "_line" pt3 pt303 "")
      (setq label1 (entlast)
	    sset1   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt306 pt304 ""
            "_line" pt300 pt301 "")
      (command "_'layer" "s" "Thin 2" "")
  (command "_line" pt307 pt302 "")
  (command "_pline" pt301 "_a" "_r" (* 2 htv) pt302 
                               "_r" (* 2 htv) pt303 
                               "_r" (* 1.5 dlnd) pt304 
                               "_r" (* 2 htv) pt305 
                               "_r" (* 1.2 htv) pt306 "")
  (setvar "clayer" clay)
) ;_end of uzelnarned
;;--------------------------------------------------------------------
(if (eq strg1 "1")
    (progn (setq tvst pt300) (uzelnarned))
    (progn (setq tvst pt7v) (uzelvnned))
)

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_ end of while
  ) ;_end of RIS-UZELN

(defun edat2 ()
    (setq edat32 (strcat "K1YZ" strg1 ndrn1  ndru1 
                    (itoa (fix (* 10 dlnd)))
                    (itoa (fix (* 100 shagv)))))
 ) ;_end of defun EDAT2
  (defun clip_bl2 ()
    (edat2)
    (if	(eq (tblsearch "block" edat32) nil)
      (progn
	(ris_uzeln)
	(command "._block" edat32 tvst sset1 "")
	(setvar "aperture" apsz)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(command "._insert" edat32 pause 1 1 pause)
      ) ;_end of progn
      (progn
	(setvar "clayer" clay)
	(command "._insert" edat32 pause 1 1 pause)
      ) ;_end of progn
    ) ;_ end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "osnapcoord" oscor) 
  ) ;_ end of defun clip_bl2
 (clip_bl2)
  (prin1)
)
