;;------------> KVADRAT <------------------------------------------------------
;                        
;             
;            
;            ,   
;;------------------------------------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;; 20/08/99  AutoCAD r15 (2000)
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;error function
(defun *error* (msg)
 (setq msg "Function Abort by user")
 (princ)
 (princ msg)
 (princ)
)
;;------------------------------------------------------------------------
(defun perc ( )
 (setq p1 (getpoint "\n : ")
      akv (getdist p1 "\n A: ")
      bkv (getdist p1 "\n B: ")
       p2 (list (-(car p1)  (/ akv 2.0)) (-(cadr p1) (/ bkv 2.0))
           )	;  ->      p2
 )
)
;;------------------------------------------------------------------------
(defun perl ( )
(setq p1 (getpoint "\n  : ")
     akv  (getdist p1 "\n  A: ")
     bkv  (getdist p1 "\n   B: ")
      p2 (list (car p1) (cadr p1)) ;    p2 
 )            
)
;;------------------------------------------------------------------------
;---------->  MAIN FUNCTION <----------------------------------------------
(defun c:kvadrat ( / pr p3 p4 p5 d  cmd1 blm)

 (setq d nil
    cmd1 (getvar "CMDECHO")    ; 
     blm (getvar "BLIPMODE")
      pr (strcase (getstring "\n  <L>    <C>  :  <C> "))
 )
 (initget 3) 
 (cond ((or (= pr "C") (= pr "")) (perc) )
       (      (= pr "L")          (perl) ) ;  pr -> p2
 )  ; close COND
 (setq
      p3   (list (car p2)        (+(cadr p2) bkv))
      p4   (list (+(car p3) akv) (cadr p3)       )
      p5   (list (car p4)        (cadr p2)       )
      d    (getreal "\n   <Enter>,    : ")
 )
 (setvar "CMDECHO" 0)
 (setvar "BLIPMODE" 0)
 (if (/= d nil) ;   ,   
       (progn 
            (setq d (/ d 2.0) )  
            (COMMAND "CIRCLE" p2 d)
            (COMMAND "CIRCLE" p3 d)
            (COMMAND "CIRCLE" p4 d)
            (COMMAND "CIRCLE" p5 d)
       )
       (COMMAND "PLINE" p2 p3 p4 p5 "c") ;  -  
  )

 (setvar "CMDECHO" cmd1) ; 
 (setvar "BLIPMODE" blm)
 (setq  pr nil   p2 nil   p3 nil ;   
        p4 nil  akv nil  bkv nil 
        p5 nil   p1 nil    d nil
 )
(princ)
)
;;------------> The End --------------------------------------------------
